// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ControlsDemo.h"

#include "MainFrm.h"

#include "ModalTestDlg.h"
#include "ButtonsDlg.h"
#include "EditDlg.h"
#include "ListboxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
  ON_COMMAND(ID_CONTROLS_MODALDIALOG, OnControlsModaldialog)
  ON_COMMAND(ID_CONTROLS_BUTTONS, OnControlsButtons)
  ON_COMMAND(ID_CONTROLS_LISTBOX, OnControlsListbox)
  ON_COMMAND(ID_CONTROLS_EDITCONTROL, OnControlsEditcontrol)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
  cs.style &= ~FWS_ADDTOTITLE;
  if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers


void CMainFrame::OnControlsModaldialog()
{
  CModalTestDlg dlg;
  int nRet = dlg.DoModal();

   // Handle the return value from DoModal
   switch (nRet)
   {
   case -1: 
      AfxMessageBox("Dialog box could not be created!");
      break;
   case IDABORT:
      AfxMessageBox("Dialog aborted");
      break;
   case IDOK:
      AfxMessageBox("OK button pressed");
      break;
   case IDCANCEL:
      AfxMessageBox("Cancel button pressed");
      break;
   default:
      AfxMessageBox("Unknown result");
      break;
  }
}

void CMainFrame::OnControlsButtons()
{
  CButtonsDlg().DoModal();
}

void CMainFrame::OnControlsListbox()
{
  CListBoxDlg().DoModal();
}

void CMainFrame::OnControlsEditcontrol()
{
  CEditDlg().DoModal();
}
